
#include "shared.h"

#if defined(USE_GBFS)
#include <gbfs.h>
#endif

#if defined(USE_GBFS)
extern const GBFS_FILE filesystem_gbfs;
#else
extern const int rom_bin_size;
extern const char rom_bin[];
#endif

#if defined(USE_GBFS)
int load_rom(const char *filename)
{
    u32 size = 0;

    cart_rom = NULL;
    GBFS_FILE const* pFileSystem = &filesystem_gbfs;

    if (pFileSystem == 0)
    {
        return -1;
    }

    cart_rom = (uint8*)gbfs_get_obj(pFileSystem, filename, &size);

    if (cart_rom == NULL)
    {
        return 0;
    }

    return size;
}
#else
int load_rom()
{
    cart_rom = (uint8*)rom_bin;
    return rom_bin_size;
}
#endif
