#include <stdio.h>
#include <stdlib.h>

int main(int argc, char** argv)
{
    if (argc != 2 && argc != 3)
    {
        printf("usage: swap <input> [output]\n");
        printf("swaps the byte order of <input> and writes the result to [output].\n");
        printf("if [output] is not given, the original file is over-written.\n");
        printf("file size must be even!\n\n");
        return 1;
    }

    FILE* fp = fopen(argv[1], "rb");
    if (fp == NULL)
    {
        printf("unable to open input file!\n");
        return 0;
    }

    fseek(fp, 0, SEEK_END);
    int length = ftell(fp);

    if (length & 1 == 1)
    {
        printf("file size is not even!\n");
        fclose(fp);
    }

    printf("swapping byte order of %s (%i bytes)\n", argv[1], length);

    fseek(fp, 0, SEEK_SET);

    char* buf = new char[length];
    fread(buf, 1, length, fp);

    for (int i = 0; i < length; i += 2)
    {
        char temp = buf[i];
        buf[i] = buf[i+1];
        buf[i+1] = temp;
    }

    fclose(fp);

    if (argc == 2)
    {
        // no output file specified - use input file
        fp = fopen(argv[1], "wb");
    }
    else
    {
        // output file specified
        fp = fopen(argv[2], "wb");
        if (fp == NULL)
        {
            printf("unable to create output file!\n");
            delete[] buf;
            return 0;
        }
    }

    fwrite(buf, 1, length, fp);
    delete[] buf;

    fclose(fp);

    printf("done\n");
    return 1;
}
